#include<stdio.h>
#include<string.h>
#include<stdlib.h>

char listing = 0;

FILE *infile;
FILE *spacefile;
FILE *outfile;
FILE *defile;
FILE *between;
FILE *last;
FILE *urbane;

char line[1000];
char qline[1000];
int linenumber;
char string;
char name;
char keyword;
char label;
char constant;
char variable;
int variable0;
int variables;
char quote;
int i;
char phrase1[1000];
char phrase2[1000];
char phrase3[1000];
char word1[1000];
char word2[1000];
char word3[1000];
char defineda[30000];
char *definedP;
char *definedv[1000];
int definedc;
char definea[30000];
char *defineP;
char defining;
int labels;
int labeling;
int constants;
int variables;
char *fromP;
char *toP;
int screenc;
int xrefc = 0;

char *xref[] = {
  " %d  %s %s\\n\", UBN_XRF_LINE_LABEL, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_KEYWORD_REFERENCE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_LINE_REFERENCE, LN_$, LINE_LABELS$[LINE_LABEL_COUNTER][LINE_LABELS_NUMBER]",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE_REFERENCE, LN_$, VLSTRING$",
  "skip",
  ""
};

char *screenv[] = {
  "q%d %s\\n\", LINE_NUMBER, IN_LINE$",
  "%d %d at %d\\n\", LINE_NUMBER, IN_LINE_CH, IN_LINE_CHAR_COUNTER",
  "%d Too many variables\", LINE_NUMBER",
  "%d Missing end quote - %s\\n\", LINE_NUMBER, QSTRING$", 
  "%d '$' should not be used in labels - %s\\n\", LINE_NUMBER, VLSTRING$",
  "%d Too many labels\", LINE_NUMBER",
  "%d Duplicate line label  - %s\\n\", LINE_NUMBER, VLSTRING$",
  "%d Too many variables\", LINE_NUMBER",
  "%d Invalid Octal Number - %s\\n\",LINE_NUMBER, HO_STRING$",
  "%d '&' not followed by 'H' or 'O' - %s\\n\", LINE_NUMBER, HO_STRING$",
  "l%d %s\\n\", LINE_NUMBER, IN_LINE$",
  "qPass %d; %d lines\\n\", PASS, LINE_COUNT",
  "q ---------PASS 2 STARTING------\\n\"",
  "q%s\\n\", UBN_TITLE$",
  "qErrs %d, Warns %d. Lines %d, Labels %d, Vars %d\\n\", ERRORS, WARNINGS, LINE_COUNT, LINE_LABEL_COUNT, VARIABLE_NAMES_COUNT",
  ""
};

char *keywords[] = {
  "REM",
  "ATTR",
  "AUDIO",
  "BACKUP",
  "CIRCLE",
  "CLEAR",
  "CLOAD",
  "CLOADM",
  "CLOSE",
  "CLS",
  "COLOR",
  "CONSTANT",
  "CONT",
  "COPY",
  "CSAVE",
  "CSAVEM",
  "DATA",
  "DEF",
  "DEFUSR",
  "DEL",
  "DIM",
  "DIR",
  "DLOAD",
  "DRAW",
  "DRIVE",
  "DSKI$",
  "DSKINI",
  "DSKO$",
  "EDIT",
  "END",
  "EXEC",
  "FIELD",
  "FILES",
  "FN",
  "FOR",
  "GET",
  "GOSUB",
  "GOTO",
  "HBUFF",
  "HCIRCLE",
  "HCLS",
  "HCOLOR",
  "HDRAW",
  "HGET",
  "HLINE",
  "HPAINT",
  "HPRINT",
  "HPUT",
  "HRESET",
  "HSCREEN",
  "HSET",
  "HSTAT",
  "IF",
  "INPUT",
  "KILL",
  "LET",
  "LINE",
  "LIST",
  "LLIST",
  "LOCATE",
  "LPOKE",
  "LOAD",
  "LOADM",
  "LSET",
  "MERGE",
  "MOTOR",
  "NEW",
  "NEXT",
  "OLD",
  "ON",
  "OPEN",
  "PAINT",
  "PALETTE",
  "PCLEAR",
  "PCLS",
  "PCOPY",
  "PLAY",
  "PMODE",
  "POKE",
  "PRESET",
  "PRINT",
  "PSET",
  "PUT",
  "READ",
  "RENAME",
  "RENUM",
  "RESET",
  "RSET",
  "RESTORE",
  "RESUME",
  "RETURN",
  "RUN",
  "SAVE",
  "SAVEM",
  "SCREEN",
  "SET",
  "SKIPF",
  "SOUND",
  "STOP",
  "TO",
  "TROFF",
  "TRON",
  "WIDTH",
  "WRITE",
  "UNLOAD",
  "VERIFY",
  "MEM",
  "TIMER",
  "AND",
  "NOT",
  "OR",
  "ELSE",
  "STEP",
  "FREE",
  "AS",
  "BRK",
  "ERR",
  "CMP",
  "RGB",
  "USING",
  "ERROR",
  "FREE",
  "OFF",
  "TAB",
  "USING",
  "THEN",
  "TO",
  "?",
  "AS",
  "OR",
  "PI",

// Functions, keywords that require next character to be an open parentheses

  "ABS",
  "ASC",
  "ATN",
  "BUTTON",
  "CHR$",
  "COS",
  "CVN",
  "EOF",
  "ERLIN",
  "ERNO",
  "EXP",
  "FIX",
  "HEX$",
  "HPOINT",
  "INKEY$",
  "INSTR",
  "INT",
  "JOYSTK",
  "LEFT$",
  "LEN",
  "LOC",
  "LOF",
  "LOG",
  "LPEEK",
  "MID$",
  "MKN$",
  "PEEK",
  "POINT",
  "POS",
  "PPOINT",
  "RIGHT$",
  "RND",
  "SGN",
  "SIN",
  "STRING$",
  "STR$",
  "SQR",
  "TAN",
  "USR",
  "VAL",
  "VARPTR",
  ""
};


// Illegal Two Character Variable Table
// NOTE "PI" is a variable that is NOT replaced

char *illegal[] = {
  "BF",
  "AS",
  "FN",
  "IF",
  "ON",
  "OR",
  "PI",
  "TO",
  ""
};

int error(char *mesg) {
  printf("%d %s %s", linenumber, mesg, line);
  exit(0);
}

char *skip2colon(char *lineP) {
  while (*lineP && *lineP!=':')  lineP++;
  return lineP;
}

char islabelchar(char intch) {
  if (intch=='_' || (intch>='A' && intch<='Z'))  return 1;
  if (intch>='0' && intch<='9')  return 1;
  return 0;
}

char isin(char *word, char **table) {
  int i=0;
  while (table[i][0]) {
    if (!strcmp(word, table[i]))  break;
    i++;
  }
  if (table[i][0])  return 1;
  return  0;
}

char *copyword(char *wordP, char *lineP) {
  while (*wordP)
    *lineP++ = *wordP++;
  *lineP = 0;
  return lineP;
}

char *getword(char *wordP, char *lineP) {
  char *word;
  int i;
  if (*lineP==' ')  lineP++;
  word = wordP;
  if (*lineP=='"') {
    *wordP++ = *lineP++;
    while (*lineP && *lineP!='"')  *wordP++ = *lineP++;
    if (*lineP=='"')  *wordP++ = *lineP++;
    *wordP = 0;
    string = 1;
    constant = 1;
    keyword = 0;
    name = 0;
    label = 0;
    variable = 0;
    return lineP;
  }
  if (islabelchar(*lineP))  name = 1;
  if (*lineP>='0' && *lineP<='9')  name = 0;
  while (*lineP && *lineP!=' ' && *lineP!='(' && *lineP!=',' && *lineP!=')') {
    if (!islabelchar(*lineP) && *lineP!='$' && *lineP!='~' &&
        !(*lineP>='a' && *lineP<='z'))  name = 0;
    *wordP++ = *lineP++;
  }
  if (word==wordP) {
    name = 0;
    if (*lineP)  *wordP++ = *lineP++;
  }
  *wordP = 0;
  if (word!=wordP && *(wordP-1)=='$')  string = 1;
  else  string = 0;
  label = 0;
  constant = 0;
  variable = 0;
  keyword = isin(word, keywords);
  if (keyword)  return lineP;
  if (!name) return lineP;
  i = 0;
  while (definedv[i][0] && strcmp(word, definedv[i]))  i++;
  if (i<labels)  label = 1;
  else if (i<constants)  constant=1;
  else variable = 1;
  if (i>=definedc) {
    definedv[definedc++] = definedP;
    definedv[definedc] = "";
    definedP = copyword(word, definedP);
    *definedP++ = 0;
    if (defining)  return lineP;
    if (string) {
      if (!strcmp(word, "IN_LINE$"))
        fprintf(defile, "char %s[300];\n", word);
      else fprintf(defile, "char %s[300];\n", word);
    }
    else fprintf(defile, "int %s;\n", word);
  }
  return lineP;
}

char *copylabel(FILE *outfile, char *lineP) {
  char word[1000];
  lineP = getword(word, lineP);
  fprintf(outfile, word);
  return lineP;
}

char *getphrase(char *phraseP, char *lineP) {
  char *phrase;
  char stringtype;
  char *charP;
  char word[1000];
  char stack[1000];
  char *stackP;
  stackP = stack;
  *stackP = 0;
  phrase = phraseP;
  if (!*lineP)  error("empty phrase");
  charP = getword(word, lineP);
  stringtype = string;
  if (!name && !constant)  error("not name in phrase");
  do {
    if (!strcmp(word, "(")) {
      *phraseP++ = '[';
      *++stackP = ']';
    }
    else if (!strcmp(word, "MID$"))  {
      phraseP = copyword("mid$(temp$,", phraseP);
      charP = getword(word, charP);
      *++stackP = 'f';
    }
    else if (!strcmp(word, ",")) {
      if (*stackP=='f') {
        phraseP = copyword(", ", phraseP);
        *stackP = 's';
      }
      else if (*stackP=='s') {
        phraseP = copyword(", ", phraseP);
        *stackP = ')';
      }
      else phraseP = copyword("][", phraseP);
    }
    else if (!strcmp(word, ")")) {
      if (*stackP=='s') {
        phraseP = copyword(", 0)", phraseP);
        stackP--;
      }
      else  *phraseP++ = *stackP--;
    }
    else if (!strcmp(word, "ASC") || !strcmp(word, "CHR$")
        || !strcmp(word, "LEN")) {
      if (!strcmp(word, "ASC"))  phraseP = copyword("asc", phraseP);
      else if (!strcmp(word, "CHR$"))  phraseP = copyword("chr$", phraseP);
      else if (!strcmp(word, "LEN"))  phraseP = copyword("len", phraseP);
      charP = getword(word, charP);
      phraseP = copyword(word, phraseP);
      *++stackP = ')';
    }
    else {
      if (keyword)  error("keyword in phrase");
      phraseP = copyword(word, phraseP);
    }
    *phraseP = 0;
    lineP = charP;
    charP = getword(word, lineP);
  }
  while (*stackP || !strcmp(word, "("));
  *phraseP = 0;
  string = stringtype;
  return lineP;
}

int main(int argc, char **argv) {

  int intch;
  char eol;
  char *lineP;
  char *oldlineP;
  char ch;
  char *charP;
  int returns;
  int fors;
  int forvar;
  int parens;
  char skipsemi = 0;
  char brace = 0;

  infile = fopen("ubn_in.txt", "r");
  spacefile = fopen("spaces.txt", "w");
  outfile = fopen("outfile.c", "w");
  defile = fopen("defile.c", "w");
  fprintf(defile, "#include<stdio.h>\n");
  fprintf(defile, "#include<stdlib.h>\n");
  fprintf(defile, "#include<string.h>\n\n");
  intch = fgetc(infile);
// remove multiple spaces
  while (intch!=EOF) {
    eol = 0;
    while (!eol) { 
      while (intch==13)
        intch = fgetc(infile);
      if (intch==10 || intch==EOF) {
        fputc(10, spacefile);
        if (intch!=EOF)
          intch = fgetc(infile);
        eol = 1;
      }
      else if (intch=='"'){
        fputc('"', spacefile);
        do {
          intch = fgetc(infile);
          if (intch!=EOF && intch!=10)  fputc(intch, spacefile);
        }
        while (intch!=EOF && intch!=10 && intch!='"');
        if (intch=='"')  intch = fgetc(infile);
      }
      else if (intch==' ' || intch==9) {
        fputc(' ', spacefile);
        while (intch==' ' || intch==9)
          intch = fgetc(infile);
      }
      else {
        fputc(intch, spacefile);
        intch = fgetc(infile);
      }
    }
  }
  fclose(spacefile);
  spacefile = fopen("spaces.txt", "r");
  definedP = definea;
  definedc = 0;
  definedv[0] = "";
  defining = 1;
  linenumber = 0;
  intch = fgetc(spacefile);
// collect labels
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    if (islabelchar(line[0]))  getword(word1, line);
  }
  labels = definedc;
  fclose(spacefile);
  spacefile = fopen("spaces.txt", "r");
  linenumber = 0;
  intch = fgetc(spacefile);
// collect constants
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    if (listing)  printf("%d %s\n", linenumber, line);
    if (line[0]==39)  fprintf(defile, "//%s\n", line+1);
    ch = line[11];
    line[11] = 0;
    if (!strcmp(line, "# LIST_ON :"));
    else if (!strcmp(line, "# XREF_ON :"));
    else if (!strcmp(line, "' Original "));
    else {
      if (!strcmp(line, "# CONSTANT ")) {
        fprintf(defile, "#define ");
        line[11] = ch;
        lineP = line+11;
        charP = getword(word1, lineP);
        if (!strcmp(word1, "UBN_MEM_LINE_LABEL_MAX_COUNT"))
          fprintf(defile, "%s %s", word1, "10000");
        else if (!strcmp(word1, "UBN~VERSION$")) {
          fprintf(defile, "UBN_VERSION$ %s", charP+3);
          for (lineP=charP+3, charP=word2; *lineP; lineP++)
            if (*lineP!='"')  *charP++ = *lineP;
          *charP = 0;
        }
        else if (!strcmp(word1, "UBN_TITLE$"))
          fprintf(defile,
              "UBN_TITLE$ \"Urbane %s CoCo Preprocessor.\"", word2);
        else if (!strcmp(word1, "UBN_XREF_LIST_INITIAL") ||
            !strcmp(word1, "UBN_LIST_LIST_INITIAL")) {
          line[11] = ch;
          line[33] = 0;
          fprintf(defile, "%s0", lineP);
        }
        else {
          lineP = getword(word1, lineP);
          fprintf(defile, "%s ", word1);
          if (*lineP!=' ' || *(lineP+1)!='=' || *(lineP+2)!=' ')
            error("define =");
          if (!strcmp(word1, "ASC_TAB"))  fputc('9', defile);
          else {
            ch = *(lineP+16);
            *(lineP+16) = 0;
            if (!strcmp(lineP+5, " : REM ASC(")) {
              if (*(lineP+17)==39) fprintf(defile, "39");
              else {
                fputc(39, defile);
                fputc(*(lineP+17), defile);
                fputc(39, defile);
              }
            }
            else if (!strcmp(lineP+6, " : REM ASC")) {
              fputc(39, defile);
              fputc(*(lineP+18), defile);
              fputc(39, defile);
            }
            else {
              *(lineP+16) = ch;
              fprintf(defile, lineP+3);
            }
          }
        }
      }
      if (line[0]!=39)  putc(10, defile);
      if (!strcmp(word1, "UBN_XRF_KEYWORD_REFERENCE")) {
        constants = definedc;
        break;
      }
    }
  }
  fputc(10, defile);
// define DIM's
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    lineP = line;
    if (islabelchar(line[0]))  lineP = getword(word1, lineP);
    if (lineP[1]=='D' && lineP[2]=='I' && lineP[3]=='M' && lineP[4]==' ') {
      getphrase(phrase1, lineP+4);
      fprintf(defile, "char %s[100];\n", phrase1);
      if (listing)  printf("%d %s\n", linenumber, line);
    }
  }
  fclose(spacefile);
  spacefile = fopen("spaces.txt", "r");
  linenumber = 0;
  defining = 0;
  intch = fgetc(spacefile);
// skip constants
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    if (!strcmp(line, "# CONSTANT UBN_XRF_KEYWORD_REFERENCE = 8"))  break;
  }
  *lineP = 0;
// define variables
  variable0 = definedc;
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    *lineP = 0;
    lineP = line;
    while (*lineP) {
      if (*lineP==39)  break;
      lineP=getword(word1, lineP);
      if (!strcmp(word1, "DATA"))  break;
      if (!strcmp(word1, "REM"))  break;
    }
  }
  variables = definedc;
  fclose(spacefile);
  spacefile = fopen("spaces.txt", "r");
  linenumber = 0;
  intch = fgetc(spacefile);
// skip constants
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    if (!strcmp(line, "# CONSTANT UBN_XRF_KEYWORD_REFERENCE = 8"))  break;
  }
  *lineP = 0;
  labeling = 0;
  ch = intch;
  between = fopen("betweenBC.c", "r");
  intch = fgetc(between);
// do code
  while (intch!=EOF) {
    while (intch==13)  intch = fgetc(between);
    fputc(intch, outfile);
    intch = fgetc(between);
  }
  fclose(between);
  intch = ch;
  fputc(10, outfile);
  returns = 0;
  fors = 0;
  while (intch!=EOF) {
    eol = 0;
    lineP = line;
    linenumber++;
    while (!eol) {
      while (intch==13)
        intch = fgetc(spacefile);
      if (intch==10 || intch==EOF) {
        *lineP++ = 0;
        if (intch!=EOF)
          intch = fgetc(spacefile);
        eol = 1;
      }
      else {
        *lineP++ = intch;
        intch = fgetc(spacefile);
      }
    }
    word1[0] = 0;
    lineP = line;
    fromP = line;
    toP = qline;
    quote = 0;
    while (*fromP) {
      if (*fromP=='"')   quote = 1;
      if (*fromP=='"' || *fromP=='\\')  *toP++ = '\\';
      if (*fromP=='\\')   quote = 0;
      *toP++ = *fromP++;
    }
    *toP = 0;
    if (listing)  printf("%d %s\n", linenumber, line);
    if (!strcmp(line+1, " Add existing 2ch variable to output string"))
      fprintf(outfile, "havevariable() ;\n");
    if (!strcmp(line+1, " Skip blanks"))
      fprintf(outfile, "havechar() ;\n");
    if (line[0]==39) {
      fprintf(outfile, "  //%s", line+1);
    }
    else {
      if ((line[0]>='A' && line[0]<='Z') || line[0]=='_') {
        labeling++;
        lineP = getword(word3, lineP);
        if (!strcmp(word3, "COLUMN_ONE") || !strcmp(word3, "LOAD_KEYWORDS"))
          fprintf(outfile, "// %s\n", word3);
        else  fprintf(outfile, "%s:\n", word3);
        if (!strcmp(word3, "VLSTRING_ADD_LOWER_ALPHA"))
          fprintf(outfile, "  goto VLSTRING_ADD_UPPER_ALPHA ;\n");
        if (!strcmp(word3, "NEXT_LINE")) {
          fprintf(outfile, "  nextline() ;\n");
          fprintf(outfile, "  IN_LINE_CH = ASC_TILDE ;\n");
        }
        if (!strcmp(word3, "HAVE_KEYWORD")) {
          fprintf(outfile, "  if (!strcmp(VLSTRING$, \"DATA\")) {\n");
          fprintf(outfile, "    join(1, OUTPUT_STRING$, OUTPUT_STRING$, ");
          fprintf(outfile, "\"DATA \") ;\n");
          fprintf(outfile, "    join(1, OUTPUT_STRING$, OUTPUT_STRING$, ");
          fprintf(outfile, "IN_LINE$+IN_LINE_CHAR_COUNTER) ;\n");
          fprintf(outfile, "    goto OUTPUT_LINE ;\n");
          fprintf(outfile, "  }\n");
          fprintf(outfile, "  havekeyword() ;\n");
        }
        if (!strcmp(word3, "HAVE_LINE_LABEL"))
          fprintf(outfile, "  havelabel() ;\n");
        if (!strcmp(word3, "ADD_NUMBER"))
          fprintf(outfile, "  havenumber() ;\n");
        fprintf(outfile, "  if (label)  ");
        fprintf(outfile, "fprintf(bug, \"\\n%d ", linenumber);
        fprintf(outfile, "\") ;\n  if (tron)  fprintf(bug, \"\\n\")");
        if (!strcmp(lineP, " REM || !*lineP"))  lineP = skip2colon(lineP);
        else  fprintf(outfile, " ;\n");
      }
      fprintf(outfile, "  if (tron)  fprintf(bug, \"\\n%d  %s\") ;\n",
         linenumber,  qline);
      if (*lineP==' ') {
        fputc(*lineP++, outfile);
        fputc(' ', outfile);
        oldlineP = NULL;
        while (*lineP) {
          charP = getword(word1, lineP);
          if (!strcmp(line, " IN_LINE_CH = ASC(IN_LINE_CH$)")) {
            fprintf(outfile, "if (label || tron)  fprintf(bug, ");
            fprintf(outfile, "\"  %cs\", IN_LINE_CH$) ;\n  ", '%');
          }
          if (!strcmp(line, " GOTO NEXT_VLSTRING_CH")) {
            fprintf(outfile, "\n  if (label || tron) fprintf(bug, ");
            fprintf(outfile, "\"  %cs\", VLSTRING$) ;\n  ", '%');
          }
          if (!strcmp(word1, "IF")) {
            fprintf(outfile, "  if (");
            getword(word2, charP);
            if (!strcmp(word2, "INSTR")) {
              for (i=0; i<7; i++)  charP = getword(word2, charP);
              fprintf(outfile, "instr(IN_LINE$, %s)", word2);
              for (i=0; i<4; i++)  charP = getword(word3, charP);
              lineP = charP;
            }
            else do {
              lineP = getphrase(phrase1, charP);
              if (!lineP)  return 0;
              lineP = getword(word1, lineP);
              lineP = getphrase(phrase2, lineP);
              if (!lineP)  return 0;
              if (!strcmp(phrase2, "\"\\\""))  copyword("\"\\\\\"", phrase2);
              if (!strcmp(word1, "="))  copyword("==", word1);
              if (!strcmp(word1, "<>"))  copyword("!=", word1);
              if (string)  fprintf(outfile, "strcmp(%s, %s) %s 0",
                  phrase1, phrase2, word1);
              else  fprintf(outfile, "%s %s %s", phrase1, word1, phrase2);
              charP = getword(word1, lineP);
              if (!strcmp(word1, "+") || !strcmp(word1, "-")) {
                lineP = getphrase(phrase1, charP);
                if (!lineP)  return 0;
                fprintf(outfile, " %s %s", word1, phrase1);
                charP = getword(word1, lineP);
              }
              if (!strcmp(word1, "AND"))  fprintf(outfile, " && ");
              if (!strcmp(word1, "OR"))  fprintf(outfile, " || ");
            }
            while (!strcmp(word1, "AND") || !strcmp(word1, "OR"));
            fprintf(outfile, " ) {");
            brace = 1;
            if (!strcmp(word1, "THEN"))  lineP = charP;
          }
          else if (!strcmp(word1, "GOTO")) {
            fprintf(outfile, "goto ");
            lineP = charP;
            lineP = copylabel(outfile, lineP);
            if (!lineP)  return 0;
          }
          else if (!strcmp(word1, ":")) {
            fprintf(outfile, " ; ");
            lineP = charP;
          }
          else if (!strcmp(word1, "RETURN")) {
            fprintf(outfile, "goto returns");
            lineP = charP;
          }
          else if (!strcmp(word1, "GOSUB")) {
            fprintf(outfile, "*forP++ = -1; *returnP++ = %d ; goto ", returns);
            lineP = charP;
            lineP = copylabel(outfile, lineP);
            fprintf(outfile, " ;\nreturn%d:", returns++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
          }
          else if (!strcmp(word1, "REM")) {
            lineP = charP;
            if (*lineP) {
              fprintf(outfile, " // %s", lineP);
              fputc(10, outfile);
              *lineP = 0;
            }
          }
          else if (!strcmp(word1, "STOP")) {
            fprintf(outfile, "  return 0");
            lineP = charP;
          }
          else if (!strcmp(word1, "NEXT")) {
            lineP = charP;
            charP = getword(word2, charP);
            if (variable) {
              for (i=variable0; i<variables; i++)
                if (strcmp(word2, definedv[i]))  break;
              if (i>=variables)  error("next forvar");
              forvar = i;
              lineP = charP;
            }
            else  forvar = 0;
            fprintf(outfile, "forvar = %d; ", forvar);
            fprintf(outfile, "back = %d; ", returns);
            fprintf(outfile, "goto next;\n");
            fprintf(outfile, "return%d:", returns++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
          }
          else if (!strcmp(word1, "PRINT")) {
            charP = getword(word1, charP);
            if (!strcmp(word1, "#FILE_L")) {
              if (!strcmp(charP, ", \" MEM = \" ; MEM")) {
                fprintf(outfile, "//%s", line);
                skipsemi = 1;
              }
              else if (!screenv[screenc][0])   error("eol screenv");
              else if (screenv[screenc][0]=='q' || screenv[screenc][0]=='l') {
                fprintf(outfile,
                  "if (!quiet)  printf(\"%s) ;\n", screenv[screenc]+1);
                if (screenv[screenc][0]=='l') {
                  fprintf(outfile, "fprintf(file_l, ");
                  fprintf(outfile, "\" %s)", screenv[screenc]+1);
                }
                screenc++;
              }
              else {
                fprintf(outfile, "printf(\"%s) ;\n", screenv[screenc]);
                fprintf(outfile, "  fprintf(file_e, ");
                fprintf(outfile, "\" %s) ;\n", screenv[screenc]);
//              fprintf(outfile, "fprintf(file_l, ");
//              fprintf(outfile, "\" %s)", screenv[screenc]);
                screenc++;
              }
            }
            else if (!strcmp(word1, "#FILE_O")) {
              fprintf(outfile, "\n    if (VLSTRING_COUNT==1 && ");
              fprintf(outfile, "hasalabel)  join(1, OUTPUT_STRING$, ");
              fprintf(outfile, "OUTPUT_STRING$, \" REM\") ;\n");
              fprintf(outfile, "    fprintf(file_o, ");
              fprintf(outfile, "\"%cs\\n\", OUTPUT_STRING$) ;\n", '%');
              fprintf(outfile, "    qlineP$ = showquotes(OUTPUT_STRING$) ;\n");
              fprintf(outfile, "    if (echo)  fprintf(bug, ");
              fprintf(outfile, "\"\\n++++++ %cs\", qlineP$)", '%');
              fprintf(outfile, " ;\n  ");
              skipsemi = 1;
            }
            else if (!strcmp(word1, "#FILE_X")) {
              if (!xref[xrefc][0])   error("eol xref");
              else if (strcmp(xref[xrefc], "skip")){
                fprintf(outfile, "fprintf(file_x, ");
                fprintf(outfile, "\" %s)", xref[xrefc++]);
              }
            }
            else {
              if (lineP!=line+1) fprintf(outfile, " ; ");
//          fprintf(outfile, "// PRINT %s", word1);
              skipsemi = 1;
            }
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "FOR")) {
            if (!(charP = getphrase(phrase1, charP)))  return 0;
            if (string)  error("string for FOR index");
            charP = getword(word2, charP);
            if (!(charP = getphrase(phrase2, charP)))  return 0;
            if (string)  error("string for FOR index");
            charP = getword(word3, charP);
            if (!(charP = getphrase(phrase3, charP)))  return 0;
            if (string)  error("string for FOR index");
            if (strcmp(word2, "=") || strcmp(word3, "TO"))
              error("for syntax");
            for (i=variable0; i<variables; i++)
              if (strcmp(phrase1, definedv[i]))  break;
            if (i>=variables)  error("for forvar");
            fprintf(outfile, "*forP++ = %d; ", i);
            fprintf(outfile, "*returnP++ = %d;\n", returns);
            lineP = charP;
            fprintf(outfile, "  %s=%s; goto for%d;\n", phrase1, phrase2, fors);
            fprintf(outfile, "return%d:\n", returns++);
            fprintf(outfile, "  %s=%s+1; if (%s>%s) goto forgone;\n",
                phrase1, phrase1, phrase1, phrase3);
            fprintf(outfile, "for%d:", fors++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              printf("\n%s\n", word1);
              if (strcmp(word1, ":"))  error("not a colon");
            }
          }
          else if (!strcmp(word1, "LINE")) {
            fprintf(outfile, "input(IN_LINE$) ;\n");
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "ON")) {
            fprintf(outfile, "if (PASS==1) goto OUTPUT_LINE;");
            for (i=0; i<5; i++)  charP = getword(word2, charP);
            fprintf(outfile, " else goto %s;", word2);
            skipsemi = 1;
            lineP = charP;
          }
          else if (!strcmp(word1, "DIM") || !strcmp(word1, "DATA") ||
              !strcmp(word1, "FILES") || !strcmp(word1, "PCLEAR") ||
              !strcmp(word1, "CLEAR")) {
            fprintf(outfile, "// %s", word1);
            lineP = skip2colon(charP);
            skipsemi = 1;
          }
          else if (!strcmp(word1, "READ")) {
            lineP = getphrase(phrase1, charP);
            if (!lineP)  return 0;
            fprintf(outfile, "i = 0; ");
            fprintf(outfile, "while ((%s[i] = datav[datac][i]))", phrase1);
            fprintf(outfile, "  i++; datac++;");
            skipsemi = 1;
          }
          else if (!strcmp(word1, "LNR_$")) {
            fprintf(outfile, "let(0,LN_$,str$(LINE_NUMBER));\n");
            fprintf(outfile, "  goto returns");
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "CLOSE")) {
            lineP = getword(word2, charP);
            if (!strcmp(word2, "FILE_I") || !strcmp(word2, "NUM_1"))
              copyword("file_i", word2);
            else if (!strcmp(word2, "FILE_O") || !strcmp(word2, "NUM_2"))
              copyword("file_o", word2);
            else if (!strcmp(word2, "FILE_X")) {
              fprintf(outfile, "  if(!ERRORS && !WARNINGS && quiet)  ");
              fprintf(outfile, "printf(\"[no errors]\\n\") ;\n");
            }
            else {
//          fprintf(outfile, "// CLOSE %s", word2);
              skipsemi = 1;
            }
            if (!strcmp(word2, "file_i") || !strcmp(word2, "file_o"))
              fprintf(outfile, "fclose(%s)", word2);
          }
          else if (!strcmp(word1, "OPEN")) {
            for (i=0; i<3; i++)  charP = getword(word2, charP);
            if (!strcmp(word2, "#NUM_1")) {
              fprintf(outfile, "parse(argc, argv) ;\n");
              fprintf(outfile, "  file_i = fopen(argv[1], \"r\")");
            }
            else if (!strcmp(word2, "#NUM_2"))
              fprintf(outfile, "file_o = fopen(fileoutname, \"w\")");
            else  {
//          fprintf(outfile, "// OPEN %s",word2);
              skipsemi = 1;
            }
            lineP = skip2colon(charP);
          }
          else if (!strcmp(word1, "END")) {
            fprintf(outfile, "if (errors && (ERRORS || WARNINGS)) {\n");
            fprintf(outfile, "    fclose(file_o);\n");
            fprintf(outfile, "    file_o = fopen(fileoutname, \"w\");\n");
            fprintf(outfile, "    fclose(file_e);\n");
            fprintf(outfile, "    file_e = fopen(\"errors.txt\", \"r\");\n");
            fprintf(outfile, "    intch = fgetc(file_e);\n");
            fprintf(outfile, "    while (intch!=EOF) {\n");
            fprintf(outfile, "      fputc(intch, file_o);\n");
            fprintf(outfile, "      intch = fgetc(file_e);\n");
            fprintf(outfile, "    }\n");
            fprintf(outfile, "  }\n");
            fprintf(outfile, "  return 0");
            lineP = skip2colon(lineP);
          }
          else if (!strcmp(line, " I_EOF = EOF(FILE_I)")) {
            fprintf(outfile, "  qlineP$ = showquotes(IN_LINE$) ;\n"); 
            fprintf(outfile, "  if (label || tron)  fprintf(bug, \"\\n\") ;\n");
            fprintf(outfile, "  if (echo)  fprintf(bug, ");
            fprintf(outfile, "\"\\n****** %cd %cs\", LINE_NUMBER, qlineP$) ;\n",
                '%', '%');
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"tron\"))");
            fprintf(outfile, "  tron = 1 ;\n");
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"label\"))");
            fprintf(outfile, "  label = 1 ;\n");
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"debug\"))");
            fprintf(outfile, "  debug = 1 ;\n");
            fprintf(outfile, "  if ((PASS==2 && !strcmp(IN_LINE$, \"echo\"))");
            fprintf(outfile, " || label || tron)  echo = 1 ;\n");
            fprintf(outfile, "  if (PASS==2 && !strcmp(IN_LINE$, \"exit\"))");
            fprintf(outfile, "  exit(0) ;\n");
            fprintf(outfile, "  I_EOF = eof");
            lineP = skip2colon(line);
          }
          else if (!strcmp(line, " "))  skipsemi = 1;
          else {
            charP = getphrase(phrase1, lineP);
            if (!charP)  return 0;
            if (string) {
              charP = getword(word2, charP);
              getword(word3, charP);
              if (!strcmp(word3, "LEFT$")) {
                fprintf(outfile, "QSTRING$[QSTRING_LENGTH] = 0");
                charP = skip2colon(charP);
              }
              else {
                charP = getphrase(phrase2, charP);
                if (!charP) return 0;
                if (!string)  error("string mismatch");
                getword(word3, charP);
                if (!strcmp(word2, "=") && strcmp(word3, "+")) {                
                  fprintf(outfile, "if (let(%d, ", linenumber);
                  fprintf(outfile, "%s, %s))  return 0", phrase1, phrase2);
                }
                else if (!strcmp(word2, "=") && !strcmp(word3, "+")) {
                  charP = getword(word3, charP);
                  charP = getphrase(phrase3, charP);
                  if (!string)  error("string mismatch");
                  fprintf(outfile, "if (join(%d, %s, %s, %s)) return 0",
                      linenumber, phrase1, phrase2, phrase3);
                }
                else error("string 1");
              }
              lineP = charP;
            }
            else {
              charP = getword(word2, charP);
              if (!strcmp(word2, "=")) {
                charP = getphrase(phrase2, charP);
                if (!charP)  return 0;
                fprintf(outfile, "%s = %s", phrase1, phrase2);
                if (string)  error("mismatch");
                lineP = charP;
                charP = getword(word2, charP);
                parens = 0;
                while (!strcmp(word2, "+") || !strcmp(word2, "-") ||
                    !strcmp(word2, "*") || !strcmp(word2, "/") ||
                    !strcmp(word2, "(") || !strcmp(word2, ")")) {
                  fprintf(outfile, " %s", word2);
                  lineP = charP;
                  charP = getword(word2, lineP);
                  if (!strcmp(word2, "(")) {
                    parens++;
                    fprintf(outfile, " (");
                    lineP = charP;
                  }
                  charP = getphrase(phrase3, lineP);
                  if (!charP)  return 0;
                  if (string)  error("string mismatch");
                  fprintf(outfile, " %s", phrase3);
                  lineP = charP;
                  charP = getword(word2, charP);
                  if (!strcmp(word2, ")")) {
                    parens--;
                    fprintf(outfile, " )");
                    lineP = charP;
                    charP = getword(word2, lineP);
                  }
                }
                if (parens)  error("parens");
              }
            }
          }
          if (lineP==oldlineP) {
            printf("%d %s", linenumber, line);
            return 0;
          }
          oldlineP = lineP;
        }
        if (!(!strcmp(word1, "REM") || skipsemi ||
             !strcmp(word1, "FOR") || !strcmp(word1, "GOSUB")))
          fprintf(outfile, " ;");
        skipsemi = 0;
        if (brace)  fprintf(outfile, "}");
        brace = 0;
      }
    }
    if (strcmp(word1, "REM")) {
      fputc(10, outfile);
    }
  }
  fputc(10, outfile);
  for (i=labeling; i<labels; i++)
    fprintf(outfile, "%s:\n", definedv[i]);
  last = fopen("last.c", "r");
  intch = fgetc(last);
  while (intch!=EOF) {
    fputc(intch, outfile);
    intch = fgetc(last);
    if (intch==13)  error("carriage return");
  }
  for (i=0; i<returns; i++) {
    fprintf(outfile, "    case %d: goto return%d;\n", i, i);
  }
  fprintf(outfile, "  }\n  return 0;\n}\n");
  fclose(outfile);
  outfile = fopen("outfile.c", "r");
  intch = fgetc(outfile);
  while (intch!=EOF) {
    fputc(intch, defile);
    intch = fgetc(outfile);
    if (intch==13)  error("carriage return");
  }
  fclose(defile);
  defile = fopen("defile.c", "r");
  urbane = fopen("urbane.c", "w");
  intch = fgetc(defile);
  while (intch!=EOF) {
    fputc(intch, urbane);
    intch = fgetc(defile);
  }
  fclose(infile);
  fclose(spacefile);
  fclose(outfile);
  return 0;
}
