
char label = 0;
char tron = 0;
char echo = 0;
char debug = 0;
char quiet = 0;
char errors = 0;

char *datav[] = {
  "REM",
  "ATTR",
  "AUDIO",
  "BACKUP",
  "CIRCLE",
  "CLEAR",
  "CLOAD",
  "CLOADM",
  "CLOSE",
  "CLS",
  "COLOR",
  "CONSTANT",
  "CONT",
  "COPY",
  "CSAVE",
  "CSAVEM",
  "DATA",
  "DEF",
  "DEFUSR",
  "DEL",
  "DIM",
  "DIR",
  "DLOAD",
  "DRAW",
  "DRIVE",
  "DSKI$",
  "DSKINI",
  "DSKO$",
  "EDIT",
  "END",
  "EXEC",
  "FIELD",
  "FILES",
  "FN",
  "FOR",
  "GET",
  "GOSUB",
  "GOTO",
  "HBUFF",
  "HCIRCLE",
  "HCLS",
  "HCOLOR",
  "HDRAW",
  "HGET",
  "HLINE",
  "HPAINT",
  "HPRINT",
  "HPUT",
  "HRESET",
  "HSCREEN",
  "HSET",
  "HSTAT",
  "IF",
  "INPUT",
  "KILL",
  "LET",
  "LINE",
  "LIST",
  "LLIST",
  "LOCATE",
  "LPOKE",
  "LOAD",
  "LOADM",
  "LSET",
  "MERGE",
  "MOTOR",
  "NEW",
  "NEXT",
  "OLD",
  "ON",
  "OPEN",
  "PAINT",
  "PALETTE",
  "PCLEAR",
  "PCLS",
  "PCOPY",
  "PLAY",
  "PMODE",
  "POKE",
  "PRESET",
  "PRINT",
  "PSET",
  "PUT",
  "READ",
  "RENAME",
  "RENUM",
  "RESET",
  "RSET",
  "RESTORE",
  "RESUME",
  "RETURN",
  "RUN",
  "SAVE",
  "SAVEM",
  "SCREEN",
  "SET",
  "SKIPF",
  "SOUND",
  "STOP",
  "TO",
  "TROFF",
  "TRON",
  "WIDTH",
  "WRITE",
  "UNLOAD",
  "VERIFY",
  "MEM",
  "TIMER",
  "AND",
  "NOT",
  "OR",
  "ELSE",
  "STEP",
  "FREE",
  "AS",
  "BRK",
  "ERR",
  "CMP",
  "RGB",
  "USING",
  "ERROR",
  "FREE",
  "OFF",
  "TAB",
  "USING",
  "THEN",
  "TO",
  "?",
  "AS",
  "OR",
  "PI",
  
  "ABS",
  "ASC",
  "ATN",
  "BUTTON",
  "CHR$",
  "COS",
  "CVN",
  "EOF",
  "ERLIN",
  "ERNO",
  "EXP",
  "FIX",
  "HEX$",
  "HPOINT",
  "INKEY$",
  "INSTR",
  "INT",
  "JOYSTK",
  "LEFT$",
  "LEN",
  "LOC",
  "LOF",
  "LOG",
  "LPEEK",
  "MID$",
  "MKN$",
  "PEEK",
  "POINT",
  "POS",
  "PPOINT",
  "RIGHT$",
  "RND",
  "SGN",
  "SIN",
  "STRING$",
  "STR$",
  "SQR",
  "TAN",
  "USR",
  "VAL",
  "VARPTR",
  "\\",
  "BF",
  "AS",
  "FN",
  "IF",
  "ON",
  "OR",
  "PI",
  "TO",
  "\\"
};

char *notkeyword[] = {
  "G",
  "BF",
  "B",
  "R",
  "PI",
  "\\"
};

int i;
char eof = 0;
int intch = 0;
int datac = 0;
int back;
int forvar;
int switcher;
char temp$[300];
char chrs$[256][2];
char qline$[1000];
char *qlineP$;
int *tempP;
char *fileoutname;
char gotogosub = 0;
char thenelse = 0;
char run = 0;
char needrem = 0;
char data = 0;
char hadlabel = 0;
char juststarted = 0;
char labeling = 0;
char hasalabel = 0;

FILE *file_i;
FILE *file_o;
FILE *file_e;
FILE *file_l;
FILE *file_x;
FILE *bug;

char *str$(int number) {
  int i=0;
  int divisor=10000;
  int quotient;
  char some=0;
  while (divisor) {
    quotient = number/divisor;
    if (some || quotient || divisor==1) {
      some = 1;
      LNR_$[i++] = quotient+'0';
    }
    number = number-quotient*divisor;
    divisor = divisor/10;
  }
  LNR_$[i] = 0;
  return LNR_$;
}

char join(int linenumber, char *to, char *first, char *second) {
  char *toP = to;
  char *firstP = first;
  char *secondP = second;
  int i = 0;
  char *mesg;
  mesg = "";
  if (to==second)  mesg = "string order";
  while ((*toP++ = *firstP++))  i++;
  toP--;
  while ((*toP++ = *secondP++))  if (i++>256)  break;
  if (i<257)  return 0;
  if (!mesg[0])  mesg = "string overflow";
  printf("%d %s %s\n%s", linenumber, mesg, first, second);
  return 1;
}

char let(int linenumber, char *to, char *from) {
  return join(linenumber, to, from, "");
}

void labelerror(char *mesg) {
  char *charP;
  if (strcmp(mesg, "label") && strcmp(mesg, "number")) {
    printf("%d %s - %s\n", LINE_NUMBER, mesg, VLSTRING$) ;
    fprintf(file_e, "%d %s - %s\n", LINE_NUMBER, mesg, VLSTRING$) ;
    ERRORS++;
  }
  charP = IN_LINE$+IN_LINE_CHAR_COUNTER-1;
  while (*charP==' ')  charP++;
  if (gotogosub)
    if (*charP!=',')
      gotogosub=0;
  if (thenelse)  gotogosub=0;
  needrem = thenelse = run = 0;
  hadlabel = 1;
}

void report(char *mesg) {
  if (juststarted) {
    printf("%d %s at start of line\n", LINE_NUMBER, mesg) ;
    fprintf(file_e, "%d %s at start of line\n", LINE_NUMBER, mesg) ;
    ERRORS++;
  }
  juststarted = 0;
}

char iskeyword(char *name) {
  int i;
  i = 0;
  while (strcmp(datav[i], "\\")) {
    if (!strcmp(datav[i], name))  break;
    i++;
  }
  if (strcmp(datav[i], "\\")) {
    return 1;
  }
  return 0;
}

char islabel(char *VLSTRING$) {
  for (LINE_LABEL_COUNTER = LINE_LABEL_START;
      LINE_LABEL_COUNTER<=LINE_LABEL_COUNT; LINE_LABEL_COUNTER++)
    if (!strcmp(VLSTRING$,
          LINE_LABELS$[LINE_LABEL_COUNTER][LINE_LABELS_NAME]))
      break;
  return LINE_LABEL_COUNTER<=LINE_LABEL_COUNT;
}

void havevariable() {
  needrem = juststarted = 0;
  if (gotogosub || run)  labelerror ("undefined label") ;
  thenelse = 0;
}

void havenumber() {
  report("number");
  if (gotogosub || thenelse || (run && !islabel(VLSTRING$))) {
    labelerror ("undefined label") ;
    thenelse = 0;
  }
}

void havelabel() {
  if (!gotogosub && !thenelse && !run && islabel(VLSTRING$)) {
    printf("%d bad label use - %s\n", LINE_NUMBER, VLSTRING$) ;
    fprintf(file_e, "%d bad label use - %s\n", LINE_NUMBER, VLSTRING$) ;
    ERRORS++;
  }
  labelerror("label");
}

void havekeyword () {
  if (!iskeyword(VLSTRING$)) {
    if (islabel(VLSTRING$))  havelabel();
    else  havevariable();
  }
  else {
    needrem = juststarted = 0;
    if (run || gotogosub)  labelerror("keyword instead of label");
    else if (!data) {
      if (!strcmp(VLSTRING$, "DATA"))  {
        data = 1;
        gotogosub = thenelse = run = 0;
      }
      else if (thenelse) {
        if (!strcmp(VLSTRING$, "GOTO"))  gotogosub=1;
        else if (!strcmp(VLSTRING$, "GOSUB"))  gotogosub=1;
        else if (!strcmp(VLSTRING$, "RUN")) {
          run=1;
          thenelse = 0;
        }
        else  thenelse = 0;
      }
      else {
        if (!strcmp(VLSTRING$, "GOTO") || !strcmp(VLSTRING$, "GOSUB")) {
          gotogosub = 1;
          hadlabel = 0;
        }
        if (!strcmp(VLSTRING$, "RUN"))  run=1;
        if (!strcmp(VLSTRING$, "THEN"))  thenelse=1;
        if (!strcmp(VLSTRING$, "ELSE"))  thenelse=1;
      }
    }
  }
}

void havechar() {
  if (labeling) {
    if (IN_LINE_CH==' ') {
      juststarted = 1;
      labeling = 0;
    }
  }
  if (juststarted && IN_LINE_CH!=' ') {
    report("not keyword or variable");
  }
  if (gotogosub) {
    if (!hadlabel && IN_LINE_CH==',' && IN_LINE_CH!=' ') {
      printf("%d missing label after %s\n", LINE_NUMBER, VLSTRING$) ;
      fprintf(file_e, "%d missing label after %s\n", LINE_NUMBER, VLSTRING$) ;
      ERRORS++;
    }
    else if ((IN_LINE_CH!=',' && IN_LINE_CH!=' ') ||
        (!hadlabel && IN_LINE_CH!=' ')) {
      printf("%d bad character %s after %s\n",
          LINE_NUMBER, IN_LINE_CH$, VLSTRING$) ;
      fprintf(file_e, "%d bad character %s after %s\n",
          LINE_NUMBER, IN_LINE_CH$, VLSTRING$) ;
      ERRORS++;
      if (IN_LINE_CH!=',')  gotogosub = 0;
      thenelse = run = 0;
    }
    if (IN_LINE_CH==',')  hadlabel = 0;
  }
}

void nextline() {
  data = 0;
  if (gotogosub || thenelse) {
    printf("%d missing label at eol\n", LINE_NUMBER-1);
    fprintf(file_e, "%d missing label at eol\n", LINE_NUMBER-1);
    ERRORS++;
  }
  gotogosub = thenelse = run = 0;
}

char error(char *mesg) {
  printf(mesg);
  fprintf(bug, mesg);
  return 0;
}

void parse(int argc, char **argv) {
  intch = 0;
  for (i=2; i<argc; i++) {
    if (!strcmp(argv[i], "-l"))  OUTPUT_LISTING = TRUE;
    if (!strcmp(argv[i], "-x"))  OUTPUT_XREF = TRUE;
    if (!strcmp(argv[i], "-q"))  quiet = TRUE;
    if (!strcmp(argv[i], "-e"))  errors = TRUE;
    if (argv[i][0]=='-' && argv[i][1]=='o' && argv[i][2]=='=')
      fileoutname = argv[i]+3;
    if (argv[i][0]=='-' && argv[i][1]=='l' && argv[i][2]=='=' && PASS==1)
      file_l = fopen(argv[i]+3, "w");
    if (argv[i][0]=='-' && argv[i][1]=='x' && argv[i][2]=='=' && PASS==1) {
      OUTPUT_XREF = TRUE;
      file_x = fopen(argv[i]+3, "w");
    }
  }
}


int instr(char *in_line, char *word) {
  int len;
  char *fromP;
  char *toP;
  char line[300];
  fromP = in_line;
  toP = line;
  while ((*toP++ = *fromP++));
  len = strlen(word);
  for (i=strlen(line)-len; i>0; i--) {
    line[i+len] = 0;
    if (!strcmp(word, line+i))  break;
  }
  return i;
}

void input(char *in_line) {
  char *charP;
  char name[1000];
  char *nameP;
  charP = in_line;
  eof = 0;
  if (intch!=EOF) intch = fgetc(file_i);
  else  eof = NUM_M1;
  while (intch!=EOF && intch!=10) {
    *charP++ = intch;
    intch = fgetc(file_i);
  }
  *charP = 0;
  charP = in_line;
  if ((*charP>='0' && *charP<='9') || (*charP>='a' && *charP<='z') ||
      (*charP>='A' && *charP<='Z') || *charP=='_')  hasalabel = 1;
  else  hasalabel = 0;
  nameP = name;
  if (*charP)  *nameP++ = *charP++;
  while (*charP) {
    if ((*charP>='A' && *charP<='Z') ||
        (*charP>='a' && *charP<='z') ||
        (*charP>='0' && *charP<='9') || *charP=='_')
      *nameP++ = *charP;
    else  break;
    *charP++;
  }
  *nameP = 0;
  if (PASS==2 && hasalabel && iskeyword(name)) {
    printf("%d keyword as line label - %s\n", LINE_NUMBER, name) ;
    ERRORS++;
  }
  if (hasalabel) {
    needrem = 1;
    labeling = 1;
    juststarted = 0;
  }
  else if (name[0]==' ') {
    needrem = 0;
    labeling = 0;
    juststarted = 1;
  }
  else {
    needrem = 0;
    labeling = 0;
    juststarted = 0;
  }
}

char outputrem() {
//  if (LINE_NUMBER==204)  tron = 1;
  if (IN_LINE_CH==NUM_M1 && PASS==NUM_2) {
    let (1, OUTPUT_STRING$, str$(LINE_NUMBER));
    join(1, OUTPUT_STRING$, OUTPUT_STRING$, " REM");
    return 1;
  }
  return 0;
}

int asc(char *string) {
  return string[0];
}

char *chr$(int val) {
  return chrs$[val];
}

int len(char *name) {
  int i = 0;
  while (name[i]) i++;
  return i;
}

char *mid$(char * toP, char *fromP, int begin, int length) {
  let(0, toP, fromP+begin-1);
  if (length)  toP[length] = 0;
  return toP;
}

char *showquotes(char *fromP) {
  char *toP;
  char quote;
  toP = qline$;
  quote = 0;
  while (*fromP) {
    *toP++ = *fromP++;
  }
  *toP = 0;
  return qline$;
}

int main(int argc, char **argv) {
  int *returnP;
  int returna[10000];
  int *forP;
  int fora[10000];

  returnP = returna;
  forP = fora;

  for (i=0; i<256; i++) {
    chrs$[i][0] = i;
    chrs$[i][1] = 0;
  }

  bug = fopen("bug.bas", "w");
  file_e = fopen("errors.txt", "w");

