#! /bin/bash

# This is a quick and very dirty script to compile Urbane under MinGW
# Please be sure you have MinGW gcc and mamou.exe installed...
#mamou.exe can be found in the rainbow assembler folder

echo Compiling 'convertBB'...
gcc -Wall convertBC.c -o convert

echo Executing 'convert'...
./convert

echo Compiling urbane.c...
gcc -Wall urbane.c -o urbane

echo Compiling EARLaf.c...
gcc -Wall EARLai.c -o earl

echo preprocessing boot.txt...
urbane boot.txt -q -o=b.bas

echo preprocessing earl.txt...
urbane earl.txt -q -o=earl.bas

echo assembling earl.asm...
mamou earl.asm -e -q -bin -oearl.bin
#mamou.exe can be found in the Rainbow IDE Assemblers folder

echo compiling add1.bas...
earl add1.bas add1.bin

echo compiling add2.bas...
earl add2.bas add2.bin

echo compiling add3.bas...
earl add3.bas add3.bin

echo Finshed.
